#ifndef CALC_IDW_H
#define CALC_IDW_H
#include <vector>
#include <cmath>
#include <wx/wx.h>

using namespace std;

class calculate_IDW
{
    public:
        calculate_IDW();
        ~calculate_IDW();
        void setRaster(double xRasMin, double yRasMin, double xRasMax, double yRasMax, double rasWidth);
        void setPointData(vector<double> &xData, vector<double> &yData, vector<double> &zData);
        void calculateNearestNeighbor(double rasterWidth);
        void calculateSmoothing(long numberSmoothSteps);
        void getRasterData(vector<double> &xRasData, vector<double> &yRasData, vector<double> &zRasData);
        long getCols();
        long getRows();
    protected:
    private:
        long numberRasterCols, numberRasterRows;

        vector<double> xMeasure;
        vector<double> yMeasure;
        vector<double> zMeasure;

        vector<double> xRaster;
        vector<double> yRaster;
        vector<double> zRaster;
        vector<int> idRaster;
};

#endif // CALCULATE_IDW_H
