/***************************************************************
 * Name:      getInput.cpp
 * Purpose:   Code for readaing and analyzing an ASCII-input file
 * Author:    Wolfgang Gossel (wolfgang.gossel@geo.uni-halle.de)
 * Created:   2013-11-09
 * Copyright: Wolfgang Gossel (umweltgeologie.geologie.uni-halle.de)
 * License:   GPL
 **************************************************************/
#include "getInput.h"


void getPoints::setFile(string strInputFileName)
{
    //infile2="e:\\interpolation\\idw\\small_test.txt";
    infile2=strInputFileName.c_str();
}

void getPoints::getPointsFromFile()
{
    //wxString contentFile;
    //wxString inputFileName(infile2, wxConvUTF8);
    //wxMessageBox (inputFileName);
    ifstream fin(infile2);
    getline(fin, file_content,'\t');
    //wxString contentFile(file_content.c_str(), wxConvUTF8);
    //wxMessageBox (contentFile);
}

void getPoints::analyzeFileContentXYZ()
{
    minX=9999999;
    minY=9999999;
    maxX=0;
    maxY=0;
    double x,y,z;
    wxString tmpString;


    long counter1=0, counter_token=0;
    char *token;
    char *temp_total_chars;

    const char *total_chars=file_content.c_str();
    temp_total_chars = (char*)total_chars;

    for(counter1=0;counter1<num_points;counter1++)
    {
          token = strtok((char*)temp_total_chars,",");
          x=atof(token);
          if(x<minX){minX=x;}
          if(x>maxX){maxX=x;}
          xinput.push_back(x);
          counter_token=strlen(token)+1;
          temp_total_chars=temp_total_chars+counter_token;
          token = strtok((char*)temp_total_chars,",");
          y=atof(token);
          if(y<minY){minY=y;}
          if(y>maxY){maxY=y;}
          yinput.push_back(y);
          counter_token=strlen(token)+1;
          temp_total_chars=temp_total_chars+counter_token;
          token = strtok((char*)temp_total_chars,"\n");
          z=atof(token);
          zinput.push_back(z);
          counter_token=strlen(token)+1;
          temp_total_chars=temp_total_chars+counter_token;
    }

}

void getPoints::analyzeFileContentBNA()
{
    wxString tmpString;
    tmpString<<wxT("BNA not implemented yet");
    wxMessageBox (tmpString);
}

void getPoints::analyzeFileContentGSLIB()
{
    wxString tmpString;
    tmpString<<wxT("GSLIB not implemented yet");
    wxMessageBox (tmpString);
}

long getPoints::getNumberInputPoints()
{
     char *temp;
     num_points = 0;
     long counter=0;

     const char *total_chars=file_content.c_str();
     temp = (char*)total_chars;

     while (*total_chars)
     {
           if (*total_chars == '\n'){counter++;}
           total_chars++;
     }

     num_points = counter;
     return num_points;
}

void getPoints::findBoundaries()
{
    cout<<"not implemented yet";
}

double getPoints::getMaxX()
{
    return maxX;
}

double getPoints::getMinX()
{
    return minX;
}

double getPoints::getMaxY()
{
    return maxY;
}

double getPoints::getMinY()
{
    return minY;
}

void getPoints::getInputData(vector<double> &xData, vector<double> &yData, vector<double> &zData)
{
    xData=xinput;
    yData=yinput;
    zData=zinput;
}
